#pragma once

#if (defined(_WIN32) || defined(__CYGWIN__)) && !defined(GI_STATIC_COMPILATION)
#  define _GI_EXPORT __declspec(dllexport)
#  define _GI_IMPORT __declspec(dllimport)
#elif __GNUC__ >= 4
#  define _GI_EXPORT __attribute__((visibility("default")))
#  define _GI_IMPORT
#else
#  define _GI_EXPORT
#  define _GI_IMPORT
#endif
#ifdef GI_COMPILATION
#  define _GI_API _GI_EXPORT
#else
#  define _GI_API _GI_IMPORT
#endif

#define _GI_EXTERN _GI_API extern

#define GI_VAR _GI_EXTERN
#define GI_AVAILABLE_IN_ALL _GI_EXTERN

#ifdef GLIB_DISABLE_DEPRECATION_WARNINGS
#define GI_DEPRECATED _GI_EXTERN
#define GI_DEPRECATED_FOR(f) _GI_EXTERN
#define GI_UNAVAILABLE(maj,min) _GI_EXTERN
#define GI_UNAVAILABLE_STATIC_INLINE(maj,min)
#else
#define GI_DEPRECATED G_DEPRECATED _GI_EXTERN
#define GI_DEPRECATED_FOR(f) G_DEPRECATED_FOR(f) _GI_EXTERN
#define GI_UNAVAILABLE(maj,min) G_UNAVAILABLE(maj,min) _GI_EXTERN
#define GI_UNAVAILABLE_STATIC_INLINE(maj,min) G_UNAVAILABLE(maj,min)
#endif

#if GLIB_VERSION_MIN_REQUIRED >= GLIB_VERSION_2_26
#define GI_DEPRECATED_IN_2_26 GI_DEPRECATED
#define GI_DEPRECATED_IN_2_26_FOR(f) GI_DEPRECATED_FOR (f)
#define GI_DEPRECATED_MACRO_IN_2_26 GLIB_DEPRECATED_MACRO
#define GI_DEPRECATED_MACRO_IN_2_26_FOR(f) GLIB_DEPRECATED_MACRO_FOR (f)
#define GI_DEPRECATED_ENUMERATOR_IN_2_26 GLIB_DEPRECATED_ENUMERATOR
#define GI_DEPRECATED_ENUMERATOR_IN_2_26_FOR(f) GLIB_DEPRECATED_ENUMERATOR_FOR (f)
#define GI_DEPRECATED_TYPE_IN_2_26 GLIB_DEPRECATED_TYPE
#define GI_DEPRECATED_TYPE_IN_2_26_FOR(f) GLIB_DEPRECATED_TYPE_FOR (f)
#else
#define GI_DEPRECATED_IN_2_26 _GI_EXTERN
#define GI_DEPRECATED_IN_2_26_FOR(f) _GI_EXTERN
#define GI_DEPRECATED_MACRO_IN_2_26
#define GI_DEPRECATED_MACRO_IN_2_26_FOR(f)
#define GI_DEPRECATED_ENUMERATOR_IN_2_26
#define GI_DEPRECATED_ENUMERATOR_IN_2_26_FOR(f)
#define GI_DEPRECATED_TYPE_IN_2_26
#define GI_DEPRECATED_TYPE_IN_2_26_FOR(f)
#endif

#if GLIB_VERSION_MAX_ALLOWED < GLIB_VERSION_2_26
#define GI_AVAILABLE_IN_2_26 GI_UNAVAILABLE (2, 26)
#define GI_AVAILABLE_STATIC_INLINE_IN_2_26 GLIB_UNAVAILABLE_STATIC_INLINE (2, 26)
#define GI_AVAILABLE_MACRO_IN_2_26 GLIB_UNAVAILABLE_MACRO (2, 26)
#define GI_AVAILABLE_ENUMERATOR_IN_2_26 GLIB_UNAVAILABLE_ENUMERATOR (2, 26)
#define GI_AVAILABLE_TYPE_IN_2_26 GLIB_UNAVAILABLE_TYPE (2, 26)
#else
#define GI_AVAILABLE_IN_2_26 _GI_EXTERN
#define GI_AVAILABLE_STATIC_INLINE_IN_2_26
#define GI_AVAILABLE_MACRO_IN_2_26
#define GI_AVAILABLE_ENUMERATOR_IN_2_26
#define GI_AVAILABLE_TYPE_IN_2_26
#endif

#if GLIB_VERSION_MIN_REQUIRED >= GLIB_VERSION_2_28
#define GI_DEPRECATED_IN_2_28 GI_DEPRECATED
#define GI_DEPRECATED_IN_2_28_FOR(f) GI_DEPRECATED_FOR (f)
#define GI_DEPRECATED_MACRO_IN_2_28 GLIB_DEPRECATED_MACRO
#define GI_DEPRECATED_MACRO_IN_2_28_FOR(f) GLIB_DEPRECATED_MACRO_FOR (f)
#define GI_DEPRECATED_ENUMERATOR_IN_2_28 GLIB_DEPRECATED_ENUMERATOR
#define GI_DEPRECATED_ENUMERATOR_IN_2_28_FOR(f) GLIB_DEPRECATED_ENUMERATOR_FOR (f)
#define GI_DEPRECATED_TYPE_IN_2_28 GLIB_DEPRECATED_TYPE
#define GI_DEPRECATED_TYPE_IN_2_28_FOR(f) GLIB_DEPRECATED_TYPE_FOR (f)
#else
#define GI_DEPRECATED_IN_2_28 _GI_EXTERN
#define GI_DEPRECATED_IN_2_28_FOR(f) _GI_EXTERN
#define GI_DEPRECATED_MACRO_IN_2_28
#define GI_DEPRECATED_MACRO_IN_2_28_FOR(f)
#define GI_DEPRECATED_ENUMERATOR_IN_2_28
#define GI_DEPRECATED_ENUMERATOR_IN_2_28_FOR(f)
#define GI_DEPRECATED_TYPE_IN_2_28
#define GI_DEPRECATED_TYPE_IN_2_28_FOR(f)
#endif

#if GLIB_VERSION_MAX_ALLOWED < GLIB_VERSION_2_28
#define GI_AVAILABLE_IN_2_28 GI_UNAVAILABLE (2, 28)
#define GI_AVAILABLE_STATIC_INLINE_IN_2_28 GLIB_UNAVAILABLE_STATIC_INLINE (2, 28)
#define GI_AVAILABLE_MACRO_IN_2_28 GLIB_UNAVAILABLE_MACRO (2, 28)
#define GI_AVAILABLE_ENUMERATOR_IN_2_28 GLIB_UNAVAILABLE_ENUMERATOR (2, 28)
#define GI_AVAILABLE_TYPE_IN_2_28 GLIB_UNAVAILABLE_TYPE (2, 28)
#else
#define GI_AVAILABLE_IN_2_28 _GI_EXTERN
#define GI_AVAILABLE_STATIC_INLINE_IN_2_28
#define GI_AVAILABLE_MACRO_IN_2_28
#define GI_AVAILABLE_ENUMERATOR_IN_2_28
#define GI_AVAILABLE_TYPE_IN_2_28
#endif

#if GLIB_VERSION_MIN_REQUIRED >= GLIB_VERSION_2_30
#define GI_DEPRECATED_IN_2_30 GI_DEPRECATED
#define GI_DEPRECATED_IN_2_30_FOR(f) GI_DEPRECATED_FOR (f)
#define GI_DEPRECATED_MACRO_IN_2_30 GLIB_DEPRECATED_MACRO
#define GI_DEPRECATED_MACRO_IN_2_30_FOR(f) GLIB_DEPRECATED_MACRO_FOR (f)
#define GI_DEPRECATED_ENUMERATOR_IN_2_30 GLIB_DEPRECATED_ENUMERATOR
#define GI_DEPRECATED_ENUMERATOR_IN_2_30_FOR(f) GLIB_DEPRECATED_ENUMERATOR_FOR (f)
#define GI_DEPRECATED_TYPE_IN_2_30 GLIB_DEPRECATED_TYPE
#define GI_DEPRECATED_TYPE_IN_2_30_FOR(f) GLIB_DEPRECATED_TYPE_FOR (f)
#else
#define GI_DEPRECATED_IN_2_30 _GI_EXTERN
#define GI_DEPRECATED_IN_2_30_FOR(f) _GI_EXTERN
#define GI_DEPRECATED_MACRO_IN_2_30
#define GI_DEPRECATED_MACRO_IN_2_30_FOR(f)
#define GI_DEPRECATED_ENUMERATOR_IN_2_30
#define GI_DEPRECATED_ENUMERATOR_IN_2_30_FOR(f)
#define GI_DEPRECATED_TYPE_IN_2_30
#define GI_DEPRECATED_TYPE_IN_2_30_FOR(f)
#endif

#if GLIB_VERSION_MAX_ALLOWED < GLIB_VERSION_2_30
#define GI_AVAILABLE_IN_2_30 GI_UNAVAILABLE (2, 30)
#define GI_AVAILABLE_STATIC_INLINE_IN_2_30 GLIB_UNAVAILABLE_STATIC_INLINE (2, 30)
#define GI_AVAILABLE_MACRO_IN_2_30 GLIB_UNAVAILABLE_MACRO (2, 30)
#define GI_AVAILABLE_ENUMERATOR_IN_2_30 GLIB_UNAVAILABLE_ENUMERATOR (2, 30)
#define GI_AVAILABLE_TYPE_IN_2_30 GLIB_UNAVAILABLE_TYPE (2, 30)
#else
#define GI_AVAILABLE_IN_2_30 _GI_EXTERN
#define GI_AVAILABLE_STATIC_INLINE_IN_2_30
#define GI_AVAILABLE_MACRO_IN_2_30
#define GI_AVAILABLE_ENUMERATOR_IN_2_30
#define GI_AVAILABLE_TYPE_IN_2_30
#endif

#if GLIB_VERSION_MIN_REQUIRED >= GLIB_VERSION_2_32
#define GI_DEPRECATED_IN_2_32 GI_DEPRECATED
#define GI_DEPRECATED_IN_2_32_FOR(f) GI_DEPRECATED_FOR (f)
#define GI_DEPRECATED_MACRO_IN_2_32 GLIB_DEPRECATED_MACRO
#define GI_DEPRECATED_MACRO_IN_2_32_FOR(f) GLIB_DEPRECATED_MACRO_FOR (f)
#define GI_DEPRECATED_ENUMERATOR_IN_2_32 GLIB_DEPRECATED_ENUMERATOR
#define GI_DEPRECATED_ENUMERATOR_IN_2_32_FOR(f) GLIB_DEPRECATED_ENUMERATOR_FOR (f)
#define GI_DEPRECATED_TYPE_IN_2_32 GLIB_DEPRECATED_TYPE
#define GI_DEPRECATED_TYPE_IN_2_32_FOR(f) GLIB_DEPRECATED_TYPE_FOR (f)
#else
#define GI_DEPRECATED_IN_2_32 _GI_EXTERN
#define GI_DEPRECATED_IN_2_32_FOR(f) _GI_EXTERN
#define GI_DEPRECATED_MACRO_IN_2_32
#define GI_DEPRECATED_MACRO_IN_2_32_FOR(f)
#define GI_DEPRECATED_ENUMERATOR_IN_2_32
#define GI_DEPRECATED_ENUMERATOR_IN_2_32_FOR(f)
#define GI_DEPRECATED_TYPE_IN_2_32
#define GI_DEPRECATED_TYPE_IN_2_32_FOR(f)
#endif

#if GLIB_VERSION_MAX_ALLOWED < GLIB_VERSION_2_32
#define GI_AVAILABLE_IN_2_32 GI_UNAVAILABLE (2, 32)
#define GI_AVAILABLE_STATIC_INLINE_IN_2_32 GLIB_UNAVAILABLE_STATIC_INLINE (2, 32)
#define GI_AVAILABLE_MACRO_IN_2_32 GLIB_UNAVAILABLE_MACRO (2, 32)
#define GI_AVAILABLE_ENUMERATOR_IN_2_32 GLIB_UNAVAILABLE_ENUMERATOR (2, 32)
#define GI_AVAILABLE_TYPE_IN_2_32 GLIB_UNAVAILABLE_TYPE (2, 32)
#else
#define GI_AVAILABLE_IN_2_32 _GI_EXTERN
#define GI_AVAILABLE_STATIC_INLINE_IN_2_32
#define GI_AVAILABLE_MACRO_IN_2_32
#define GI_AVAILABLE_ENUMERATOR_IN_2_32
#define GI_AVAILABLE_TYPE_IN_2_32
#endif

#if GLIB_VERSION_MIN_REQUIRED >= GLIB_VERSION_2_34
#define GI_DEPRECATED_IN_2_34 GI_DEPRECATED
#define GI_DEPRECATED_IN_2_34_FOR(f) GI_DEPRECATED_FOR (f)
#define GI_DEPRECATED_MACRO_IN_2_34 GLIB_DEPRECATED_MACRO
#define GI_DEPRECATED_MACRO_IN_2_34_FOR(f) GLIB_DEPRECATED_MACRO_FOR (f)
#define GI_DEPRECATED_ENUMERATOR_IN_2_34 GLIB_DEPRECATED_ENUMERATOR
#define GI_DEPRECATED_ENUMERATOR_IN_2_34_FOR(f) GLIB_DEPRECATED_ENUMERATOR_FOR (f)
#define GI_DEPRECATED_TYPE_IN_2_34 GLIB_DEPRECATED_TYPE
#define GI_DEPRECATED_TYPE_IN_2_34_FOR(f) GLIB_DEPRECATED_TYPE_FOR (f)
#else
#define GI_DEPRECATED_IN_2_34 _GI_EXTERN
#define GI_DEPRECATED_IN_2_34_FOR(f) _GI_EXTERN
#define GI_DEPRECATED_MACRO_IN_2_34
#define GI_DEPRECATED_MACRO_IN_2_34_FOR(f)
#define GI_DEPRECATED_ENUMERATOR_IN_2_34
#define GI_DEPRECATED_ENUMERATOR_IN_2_34_FOR(f)
#define GI_DEPRECATED_TYPE_IN_2_34
#define GI_DEPRECATED_TYPE_IN_2_34_FOR(f)
#endif

#if GLIB_VERSION_MAX_ALLOWED < GLIB_VERSION_2_34
#define GI_AVAILABLE_IN_2_34 GI_UNAVAILABLE (2, 34)
#define GI_AVAILABLE_STATIC_INLINE_IN_2_34 GLIB_UNAVAILABLE_STATIC_INLINE (2, 34)
#define GI_AVAILABLE_MACRO_IN_2_34 GLIB_UNAVAILABLE_MACRO (2, 34)
#define GI_AVAILABLE_ENUMERATOR_IN_2_34 GLIB_UNAVAILABLE_ENUMERATOR (2, 34)
#define GI_AVAILABLE_TYPE_IN_2_34 GLIB_UNAVAILABLE_TYPE (2, 34)
#else
#define GI_AVAILABLE_IN_2_34 _GI_EXTERN
#define GI_AVAILABLE_STATIC_INLINE_IN_2_34
#define GI_AVAILABLE_MACRO_IN_2_34
#define GI_AVAILABLE_ENUMERATOR_IN_2_34
#define GI_AVAILABLE_TYPE_IN_2_34
#endif

#if GLIB_VERSION_MIN_REQUIRED >= GLIB_VERSION_2_36
#define GI_DEPRECATED_IN_2_36 GI_DEPRECATED
#define GI_DEPRECATED_IN_2_36_FOR(f) GI_DEPRECATED_FOR (f)
#define GI_DEPRECATED_MACRO_IN_2_36 GLIB_DEPRECATED_MACRO
#define GI_DEPRECATED_MACRO_IN_2_36_FOR(f) GLIB_DEPRECATED_MACRO_FOR (f)
#define GI_DEPRECATED_ENUMERATOR_IN_2_36 GLIB_DEPRECATED_ENUMERATOR
#define GI_DEPRECATED_ENUMERATOR_IN_2_36_FOR(f) GLIB_DEPRECATED_ENUMERATOR_FOR (f)
#define GI_DEPRECATED_TYPE_IN_2_36 GLIB_DEPRECATED_TYPE
#define GI_DEPRECATED_TYPE_IN_2_36_FOR(f) GLIB_DEPRECATED_TYPE_FOR (f)
#else
#define GI_DEPRECATED_IN_2_36 _GI_EXTERN
#define GI_DEPRECATED_IN_2_36_FOR(f) _GI_EXTERN
#define GI_DEPRECATED_MACRO_IN_2_36
#define GI_DEPRECATED_MACRO_IN_2_36_FOR(f)
#define GI_DEPRECATED_ENUMERATOR_IN_2_36
#define GI_DEPRECATED_ENUMERATOR_IN_2_36_FOR(f)
#define GI_DEPRECATED_TYPE_IN_2_36
#define GI_DEPRECATED_TYPE_IN_2_36_FOR(f)
#endif

#if GLIB_VERSION_MAX_ALLOWED < GLIB_VERSION_2_36
#define GI_AVAILABLE_IN_2_36 GI_UNAVAILABLE (2, 36)
#define GI_AVAILABLE_STATIC_INLINE_IN_2_36 GLIB_UNAVAILABLE_STATIC_INLINE (2, 36)
#define GI_AVAILABLE_MACRO_IN_2_36 GLIB_UNAVAILABLE_MACRO (2, 36)
#define GI_AVAILABLE_ENUMERATOR_IN_2_36 GLIB_UNAVAILABLE_ENUMERATOR (2, 36)
#define GI_AVAILABLE_TYPE_IN_2_36 GLIB_UNAVAILABLE_TYPE (2, 36)
#else
#define GI_AVAILABLE_IN_2_36 _GI_EXTERN
#define GI_AVAILABLE_STATIC_INLINE_IN_2_36
#define GI_AVAILABLE_MACRO_IN_2_36
#define GI_AVAILABLE_ENUMERATOR_IN_2_36
#define GI_AVAILABLE_TYPE_IN_2_36
#endif

#if GLIB_VERSION_MIN_REQUIRED >= GLIB_VERSION_2_38
#define GI_DEPRECATED_IN_2_38 GI_DEPRECATED
#define GI_DEPRECATED_IN_2_38_FOR(f) GI_DEPRECATED_FOR (f)
#define GI_DEPRECATED_MACRO_IN_2_38 GLIB_DEPRECATED_MACRO
#define GI_DEPRECATED_MACRO_IN_2_38_FOR(f) GLIB_DEPRECATED_MACRO_FOR (f)
#define GI_DEPRECATED_ENUMERATOR_IN_2_38 GLIB_DEPRECATED_ENUMERATOR
#define GI_DEPRECATED_ENUMERATOR_IN_2_38_FOR(f) GLIB_DEPRECATED_ENUMERATOR_FOR (f)
#define GI_DEPRECATED_TYPE_IN_2_38 GLIB_DEPRECATED_TYPE
#define GI_DEPRECATED_TYPE_IN_2_38_FOR(f) GLIB_DEPRECATED_TYPE_FOR (f)
#else
#define GI_DEPRECATED_IN_2_38 _GI_EXTERN
#define GI_DEPRECATED_IN_2_38_FOR(f) _GI_EXTERN
#define GI_DEPRECATED_MACRO_IN_2_38
#define GI_DEPRECATED_MACRO_IN_2_38_FOR(f)
#define GI_DEPRECATED_ENUMERATOR_IN_2_38
#define GI_DEPRECATED_ENUMERATOR_IN_2_38_FOR(f)
#define GI_DEPRECATED_TYPE_IN_2_38
#define GI_DEPRECATED_TYPE_IN_2_38_FOR(f)
#endif

#if GLIB_VERSION_MAX_ALLOWED < GLIB_VERSION_2_38
#define GI_AVAILABLE_IN_2_38 GI_UNAVAILABLE (2, 38)
#define GI_AVAILABLE_STATIC_INLINE_IN_2_38 GLIB_UNAVAILABLE_STATIC_INLINE (2, 38)
#define GI_AVAILABLE_MACRO_IN_2_38 GLIB_UNAVAILABLE_MACRO (2, 38)
#define GI_AVAILABLE_ENUMERATOR_IN_2_38 GLIB_UNAVAILABLE_ENUMERATOR (2, 38)
#define GI_AVAILABLE_TYPE_IN_2_38 GLIB_UNAVAILABLE_TYPE (2, 38)
#else
#define GI_AVAILABLE_IN_2_38 _GI_EXTERN
#define GI_AVAILABLE_STATIC_INLINE_IN_2_38
#define GI_AVAILABLE_MACRO_IN_2_38
#define GI_AVAILABLE_ENUMERATOR_IN_2_38
#define GI_AVAILABLE_TYPE_IN_2_38
#endif

#if GLIB_VERSION_MIN_REQUIRED >= GLIB_VERSION_2_40
#define GI_DEPRECATED_IN_2_40 GI_DEPRECATED
#define GI_DEPRECATED_IN_2_40_FOR(f) GI_DEPRECATED_FOR (f)
#define GI_DEPRECATED_MACRO_IN_2_40 GLIB_DEPRECATED_MACRO
#define GI_DEPRECATED_MACRO_IN_2_40_FOR(f) GLIB_DEPRECATED_MACRO_FOR (f)
#define GI_DEPRECATED_ENUMERATOR_IN_2_40 GLIB_DEPRECATED_ENUMERATOR
#define GI_DEPRECATED_ENUMERATOR_IN_2_40_FOR(f) GLIB_DEPRECATED_ENUMERATOR_FOR (f)
#define GI_DEPRECATED_TYPE_IN_2_40 GLIB_DEPRECATED_TYPE
#define GI_DEPRECATED_TYPE_IN_2_40_FOR(f) GLIB_DEPRECATED_TYPE_FOR (f)
#else
#define GI_DEPRECATED_IN_2_40 _GI_EXTERN
#define GI_DEPRECATED_IN_2_40_FOR(f) _GI_EXTERN
#define GI_DEPRECATED_MACRO_IN_2_40
#define GI_DEPRECATED_MACRO_IN_2_40_FOR(f)
#define GI_DEPRECATED_ENUMERATOR_IN_2_40
#define GI_DEPRECATED_ENUMERATOR_IN_2_40_FOR(f)
#define GI_DEPRECATED_TYPE_IN_2_40
#define GI_DEPRECATED_TYPE_IN_2_40_FOR(f)
#endif

#if GLIB_VERSION_MAX_ALLOWED < GLIB_VERSION_2_40
#define GI_AVAILABLE_IN_2_40 GI_UNAVAILABLE (2, 40)
#define GI_AVAILABLE_STATIC_INLINE_IN_2_40 GLIB_UNAVAILABLE_STATIC_INLINE (2, 40)
#define GI_AVAILABLE_MACRO_IN_2_40 GLIB_UNAVAILABLE_MACRO (2, 40)
#define GI_AVAILABLE_ENUMERATOR_IN_2_40 GLIB_UNAVAILABLE_ENUMERATOR (2, 40)
#define GI_AVAILABLE_TYPE_IN_2_40 GLIB_UNAVAILABLE_TYPE (2, 40)
#else
#define GI_AVAILABLE_IN_2_40 _GI_EXTERN
#define GI_AVAILABLE_STATIC_INLINE_IN_2_40
#define GI_AVAILABLE_MACRO_IN_2_40
#define GI_AVAILABLE_ENUMERATOR_IN_2_40
#define GI_AVAILABLE_TYPE_IN_2_40
#endif

#if GLIB_VERSION_MIN_REQUIRED >= GLIB_VERSION_2_42
#define GI_DEPRECATED_IN_2_42 GI_DEPRECATED
#define GI_DEPRECATED_IN_2_42_FOR(f) GI_DEPRECATED_FOR (f)
#define GI_DEPRECATED_MACRO_IN_2_42 GLIB_DEPRECATED_MACRO
#define GI_DEPRECATED_MACRO_IN_2_42_FOR(f) GLIB_DEPRECATED_MACRO_FOR (f)
#define GI_DEPRECATED_ENUMERATOR_IN_2_42 GLIB_DEPRECATED_ENUMERATOR
#define GI_DEPRECATED_ENUMERATOR_IN_2_42_FOR(f) GLIB_DEPRECATED_ENUMERATOR_FOR (f)
#define GI_DEPRECATED_TYPE_IN_2_42 GLIB_DEPRECATED_TYPE
#define GI_DEPRECATED_TYPE_IN_2_42_FOR(f) GLIB_DEPRECATED_TYPE_FOR (f)
#else
#define GI_DEPRECATED_IN_2_42 _GI_EXTERN
#define GI_DEPRECATED_IN_2_42_FOR(f) _GI_EXTERN
#define GI_DEPRECATED_MACRO_IN_2_42
#define GI_DEPRECATED_MACRO_IN_2_42_FOR(f)
#define GI_DEPRECATED_ENUMERATOR_IN_2_42
#define GI_DEPRECATED_ENUMERATOR_IN_2_42_FOR(f)
#define GI_DEPRECATED_TYPE_IN_2_42
#define GI_DEPRECATED_TYPE_IN_2_42_FOR(f)
#endif

#if GLIB_VERSION_MAX_ALLOWED < GLIB_VERSION_2_42
#define GI_AVAILABLE_IN_2_42 GI_UNAVAILABLE (2, 42)
#define GI_AVAILABLE_STATIC_INLINE_IN_2_42 GLIB_UNAVAILABLE_STATIC_INLINE (2, 42)
#define GI_AVAILABLE_MACRO_IN_2_42 GLIB_UNAVAILABLE_MACRO (2, 42)
#define GI_AVAILABLE_ENUMERATOR_IN_2_42 GLIB_UNAVAILABLE_ENUMERATOR (2, 42)
#define GI_AVAILABLE_TYPE_IN_2_42 GLIB_UNAVAILABLE_TYPE (2, 42)
#else
#define GI_AVAILABLE_IN_2_42 _GI_EXTERN
#define GI_AVAILABLE_STATIC_INLINE_IN_2_42
#define GI_AVAILABLE_MACRO_IN_2_42
#define GI_AVAILABLE_ENUMERATOR_IN_2_42
#define GI_AVAILABLE_TYPE_IN_2_42
#endif

#if GLIB_VERSION_MIN_REQUIRED >= GLIB_VERSION_2_44
#define GI_DEPRECATED_IN_2_44 GI_DEPRECATED
#define GI_DEPRECATED_IN_2_44_FOR(f) GI_DEPRECATED_FOR (f)
#define GI_DEPRECATED_MACRO_IN_2_44 GLIB_DEPRECATED_MACRO
#define GI_DEPRECATED_MACRO_IN_2_44_FOR(f) GLIB_DEPRECATED_MACRO_FOR (f)
#define GI_DEPRECATED_ENUMERATOR_IN_2_44 GLIB_DEPRECATED_ENUMERATOR
#define GI_DEPRECATED_ENUMERATOR_IN_2_44_FOR(f) GLIB_DEPRECATED_ENUMERATOR_FOR (f)
#define GI_DEPRECATED_TYPE_IN_2_44 GLIB_DEPRECATED_TYPE
#define GI_DEPRECATED_TYPE_IN_2_44_FOR(f) GLIB_DEPRECATED_TYPE_FOR (f)
#else
#define GI_DEPRECATED_IN_2_44 _GI_EXTERN
#define GI_DEPRECATED_IN_2_44_FOR(f) _GI_EXTERN
#define GI_DEPRECATED_MACRO_IN_2_44
#define GI_DEPRECATED_MACRO_IN_2_44_FOR(f)
#define GI_DEPRECATED_ENUMERATOR_IN_2_44
#define GI_DEPRECATED_ENUMERATOR_IN_2_44_FOR(f)
#define GI_DEPRECATED_TYPE_IN_2_44
#define GI_DEPRECATED_TYPE_IN_2_44_FOR(f)
#endif

#if GLIB_VERSION_MAX_ALLOWED < GLIB_VERSION_2_44
#define GI_AVAILABLE_IN_2_44 GI_UNAVAILABLE (2, 44)
#define GI_AVAILABLE_STATIC_INLINE_IN_2_44 GLIB_UNAVAILABLE_STATIC_INLINE (2, 44)
#define GI_AVAILABLE_MACRO_IN_2_44 GLIB_UNAVAILABLE_MACRO (2, 44)
#define GI_AVAILABLE_ENUMERATOR_IN_2_44 GLIB_UNAVAILABLE_ENUMERATOR (2, 44)
#define GI_AVAILABLE_TYPE_IN_2_44 GLIB_UNAVAILABLE_TYPE (2, 44)
#else
#define GI_AVAILABLE_IN_2_44 _GI_EXTERN
#define GI_AVAILABLE_STATIC_INLINE_IN_2_44
#define GI_AVAILABLE_MACRO_IN_2_44
#define GI_AVAILABLE_ENUMERATOR_IN_2_44
#define GI_AVAILABLE_TYPE_IN_2_44
#endif

#if GLIB_VERSION_MIN_REQUIRED >= GLIB_VERSION_2_46
#define GI_DEPRECATED_IN_2_46 GI_DEPRECATED
#define GI_DEPRECATED_IN_2_46_FOR(f) GI_DEPRECATED_FOR (f)
#define GI_DEPRECATED_MACRO_IN_2_46 GLIB_DEPRECATED_MACRO
#define GI_DEPRECATED_MACRO_IN_2_46_FOR(f) GLIB_DEPRECATED_MACRO_FOR (f)
#define GI_DEPRECATED_ENUMERATOR_IN_2_46 GLIB_DEPRECATED_ENUMERATOR
#define GI_DEPRECATED_ENUMERATOR_IN_2_46_FOR(f) GLIB_DEPRECATED_ENUMERATOR_FOR (f)
#define GI_DEPRECATED_TYPE_IN_2_46 GLIB_DEPRECATED_TYPE
#define GI_DEPRECATED_TYPE_IN_2_46_FOR(f) GLIB_DEPRECATED_TYPE_FOR (f)
#else
#define GI_DEPRECATED_IN_2_46 _GI_EXTERN
#define GI_DEPRECATED_IN_2_46_FOR(f) _GI_EXTERN
#define GI_DEPRECATED_MACRO_IN_2_46
#define GI_DEPRECATED_MACRO_IN_2_46_FOR(f)
#define GI_DEPRECATED_ENUMERATOR_IN_2_46
#define GI_DEPRECATED_ENUMERATOR_IN_2_46_FOR(f)
#define GI_DEPRECATED_TYPE_IN_2_46
#define GI_DEPRECATED_TYPE_IN_2_46_FOR(f)
#endif

#if GLIB_VERSION_MAX_ALLOWED < GLIB_VERSION_2_46
#define GI_AVAILABLE_IN_2_46 GI_UNAVAILABLE (2, 46)
#define GI_AVAILABLE_STATIC_INLINE_IN_2_46 GLIB_UNAVAILABLE_STATIC_INLINE (2, 46)
#define GI_AVAILABLE_MACRO_IN_2_46 GLIB_UNAVAILABLE_MACRO (2, 46)
#define GI_AVAILABLE_ENUMERATOR_IN_2_46 GLIB_UNAVAILABLE_ENUMERATOR (2, 46)
#define GI_AVAILABLE_TYPE_IN_2_46 GLIB_UNAVAILABLE_TYPE (2, 46)
#else
#define GI_AVAILABLE_IN_2_46 _GI_EXTERN
#define GI_AVAILABLE_STATIC_INLINE_IN_2_46
#define GI_AVAILABLE_MACRO_IN_2_46
#define GI_AVAILABLE_ENUMERATOR_IN_2_46
#define GI_AVAILABLE_TYPE_IN_2_46
#endif

#if GLIB_VERSION_MIN_REQUIRED >= GLIB_VERSION_2_48
#define GI_DEPRECATED_IN_2_48 GI_DEPRECATED
#define GI_DEPRECATED_IN_2_48_FOR(f) GI_DEPRECATED_FOR (f)
#define GI_DEPRECATED_MACRO_IN_2_48 GLIB_DEPRECATED_MACRO
#define GI_DEPRECATED_MACRO_IN_2_48_FOR(f) GLIB_DEPRECATED_MACRO_FOR (f)
#define GI_DEPRECATED_ENUMERATOR_IN_2_48 GLIB_DEPRECATED_ENUMERATOR
#define GI_DEPRECATED_ENUMERATOR_IN_2_48_FOR(f) GLIB_DEPRECATED_ENUMERATOR_FOR (f)
#define GI_DEPRECATED_TYPE_IN_2_48 GLIB_DEPRECATED_TYPE
#define GI_DEPRECATED_TYPE_IN_2_48_FOR(f) GLIB_DEPRECATED_TYPE_FOR (f)
#else
#define GI_DEPRECATED_IN_2_48 _GI_EXTERN
#define GI_DEPRECATED_IN_2_48_FOR(f) _GI_EXTERN
#define GI_DEPRECATED_MACRO_IN_2_48
#define GI_DEPRECATED_MACRO_IN_2_48_FOR(f)
#define GI_DEPRECATED_ENUMERATOR_IN_2_48
#define GI_DEPRECATED_ENUMERATOR_IN_2_48_FOR(f)
#define GI_DEPRECATED_TYPE_IN_2_48
#define GI_DEPRECATED_TYPE_IN_2_48_FOR(f)
#endif

#if GLIB_VERSION_MAX_ALLOWED < GLIB_VERSION_2_48
#define GI_AVAILABLE_IN_2_48 GI_UNAVAILABLE (2, 48)
#define GI_AVAILABLE_STATIC_INLINE_IN_2_48 GLIB_UNAVAILABLE_STATIC_INLINE (2, 48)
#define GI_AVAILABLE_MACRO_IN_2_48 GLIB_UNAVAILABLE_MACRO (2, 48)
#define GI_AVAILABLE_ENUMERATOR_IN_2_48 GLIB_UNAVAILABLE_ENUMERATOR (2, 48)
#define GI_AVAILABLE_TYPE_IN_2_48 GLIB_UNAVAILABLE_TYPE (2, 48)
#else
#define GI_AVAILABLE_IN_2_48 _GI_EXTERN
#define GI_AVAILABLE_STATIC_INLINE_IN_2_48
#define GI_AVAILABLE_MACRO_IN_2_48
#define GI_AVAILABLE_ENUMERATOR_IN_2_48
#define GI_AVAILABLE_TYPE_IN_2_48
#endif

#if GLIB_VERSION_MIN_REQUIRED >= GLIB_VERSION_2_50
#define GI_DEPRECATED_IN_2_50 GI_DEPRECATED
#define GI_DEPRECATED_IN_2_50_FOR(f) GI_DEPRECATED_FOR (f)
#define GI_DEPRECATED_MACRO_IN_2_50 GLIB_DEPRECATED_MACRO
#define GI_DEPRECATED_MACRO_IN_2_50_FOR(f) GLIB_DEPRECATED_MACRO_FOR (f)
#define GI_DEPRECATED_ENUMERATOR_IN_2_50 GLIB_DEPRECATED_ENUMERATOR
#define GI_DEPRECATED_ENUMERATOR_IN_2_50_FOR(f) GLIB_DEPRECATED_ENUMERATOR_FOR (f)
#define GI_DEPRECATED_TYPE_IN_2_50 GLIB_DEPRECATED_TYPE
#define GI_DEPRECATED_TYPE_IN_2_50_FOR(f) GLIB_DEPRECATED_TYPE_FOR (f)
#else
#define GI_DEPRECATED_IN_2_50 _GI_EXTERN
#define GI_DEPRECATED_IN_2_50_FOR(f) _GI_EXTERN
#define GI_DEPRECATED_MACRO_IN_2_50
#define GI_DEPRECATED_MACRO_IN_2_50_FOR(f)
#define GI_DEPRECATED_ENUMERATOR_IN_2_50
#define GI_DEPRECATED_ENUMERATOR_IN_2_50_FOR(f)
#define GI_DEPRECATED_TYPE_IN_2_50
#define GI_DEPRECATED_TYPE_IN_2_50_FOR(f)
#endif

#if GLIB_VERSION_MAX_ALLOWED < GLIB_VERSION_2_50
#define GI_AVAILABLE_IN_2_50 GI_UNAVAILABLE (2, 50)
#define GI_AVAILABLE_STATIC_INLINE_IN_2_50 GLIB_UNAVAILABLE_STATIC_INLINE (2, 50)
#define GI_AVAILABLE_MACRO_IN_2_50 GLIB_UNAVAILABLE_MACRO (2, 50)
#define GI_AVAILABLE_ENUMERATOR_IN_2_50 GLIB_UNAVAILABLE_ENUMERATOR (2, 50)
#define GI_AVAILABLE_TYPE_IN_2_50 GLIB_UNAVAILABLE_TYPE (2, 50)
#else
#define GI_AVAILABLE_IN_2_50 _GI_EXTERN
#define GI_AVAILABLE_STATIC_INLINE_IN_2_50
#define GI_AVAILABLE_MACRO_IN_2_50
#define GI_AVAILABLE_ENUMERATOR_IN_2_50
#define GI_AVAILABLE_TYPE_IN_2_50
#endif

#if GLIB_VERSION_MIN_REQUIRED >= GLIB_VERSION_2_52
#define GI_DEPRECATED_IN_2_52 GI_DEPRECATED
#define GI_DEPRECATED_IN_2_52_FOR(f) GI_DEPRECATED_FOR (f)
#define GI_DEPRECATED_MACRO_IN_2_52 GLIB_DEPRECATED_MACRO
#define GI_DEPRECATED_MACRO_IN_2_52_FOR(f) GLIB_DEPRECATED_MACRO_FOR (f)
#define GI_DEPRECATED_ENUMERATOR_IN_2_52 GLIB_DEPRECATED_ENUMERATOR
#define GI_DEPRECATED_ENUMERATOR_IN_2_52_FOR(f) GLIB_DEPRECATED_ENUMERATOR_FOR (f)
#define GI_DEPRECATED_TYPE_IN_2_52 GLIB_DEPRECATED_TYPE
#define GI_DEPRECATED_TYPE_IN_2_52_FOR(f) GLIB_DEPRECATED_TYPE_FOR (f)
#else
#define GI_DEPRECATED_IN_2_52 _GI_EXTERN
#define GI_DEPRECATED_IN_2_52_FOR(f) _GI_EXTERN
#define GI_DEPRECATED_MACRO_IN_2_52
#define GI_DEPRECATED_MACRO_IN_2_52_FOR(f)
#define GI_DEPRECATED_ENUMERATOR_IN_2_52
#define GI_DEPRECATED_ENUMERATOR_IN_2_52_FOR(f)
#define GI_DEPRECATED_TYPE_IN_2_52
#define GI_DEPRECATED_TYPE_IN_2_52_FOR(f)
#endif

#if GLIB_VERSION_MAX_ALLOWED < GLIB_VERSION_2_52
#define GI_AVAILABLE_IN_2_52 GI_UNAVAILABLE (2, 52)
#define GI_AVAILABLE_STATIC_INLINE_IN_2_52 GLIB_UNAVAILABLE_STATIC_INLINE (2, 52)
#define GI_AVAILABLE_MACRO_IN_2_52 GLIB_UNAVAILABLE_MACRO (2, 52)
#define GI_AVAILABLE_ENUMERATOR_IN_2_52 GLIB_UNAVAILABLE_ENUMERATOR (2, 52)
#define GI_AVAILABLE_TYPE_IN_2_52 GLIB_UNAVAILABLE_TYPE (2, 52)
#else
#define GI_AVAILABLE_IN_2_52 _GI_EXTERN
#define GI_AVAILABLE_STATIC_INLINE_IN_2_52
#define GI_AVAILABLE_MACRO_IN_2_52
#define GI_AVAILABLE_ENUMERATOR_IN_2_52
#define GI_AVAILABLE_TYPE_IN_2_52
#endif

#if GLIB_VERSION_MIN_REQUIRED >= GLIB_VERSION_2_54
#define GI_DEPRECATED_IN_2_54 GI_DEPRECATED
#define GI_DEPRECATED_IN_2_54_FOR(f) GI_DEPRECATED_FOR (f)
#define GI_DEPRECATED_MACRO_IN_2_54 GLIB_DEPRECATED_MACRO
#define GI_DEPRECATED_MACRO_IN_2_54_FOR(f) GLIB_DEPRECATED_MACRO_FOR (f)
#define GI_DEPRECATED_ENUMERATOR_IN_2_54 GLIB_DEPRECATED_ENUMERATOR
#define GI_DEPRECATED_ENUMERATOR_IN_2_54_FOR(f) GLIB_DEPRECATED_ENUMERATOR_FOR (f)
#define GI_DEPRECATED_TYPE_IN_2_54 GLIB_DEPRECATED_TYPE
#define GI_DEPRECATED_TYPE_IN_2_54_FOR(f) GLIB_DEPRECATED_TYPE_FOR (f)
#else
#define GI_DEPRECATED_IN_2_54 _GI_EXTERN
#define GI_DEPRECATED_IN_2_54_FOR(f) _GI_EXTERN
#define GI_DEPRECATED_MACRO_IN_2_54
#define GI_DEPRECATED_MACRO_IN_2_54_FOR(f)
#define GI_DEPRECATED_ENUMERATOR_IN_2_54
#define GI_DEPRECATED_ENUMERATOR_IN_2_54_FOR(f)
#define GI_DEPRECATED_TYPE_IN_2_54
#define GI_DEPRECATED_TYPE_IN_2_54_FOR(f)
#endif

#if GLIB_VERSION_MAX_ALLOWED < GLIB_VERSION_2_54
#define GI_AVAILABLE_IN_2_54 GI_UNAVAILABLE (2, 54)
#define GI_AVAILABLE_STATIC_INLINE_IN_2_54 GLIB_UNAVAILABLE_STATIC_INLINE (2, 54)
#define GI_AVAILABLE_MACRO_IN_2_54 GLIB_UNAVAILABLE_MACRO (2, 54)
#define GI_AVAILABLE_ENUMERATOR_IN_2_54 GLIB_UNAVAILABLE_ENUMERATOR (2, 54)
#define GI_AVAILABLE_TYPE_IN_2_54 GLIB_UNAVAILABLE_TYPE (2, 54)
#else
#define GI_AVAILABLE_IN_2_54 _GI_EXTERN
#define GI_AVAILABLE_STATIC_INLINE_IN_2_54
#define GI_AVAILABLE_MACRO_IN_2_54
#define GI_AVAILABLE_ENUMERATOR_IN_2_54
#define GI_AVAILABLE_TYPE_IN_2_54
#endif

#if GLIB_VERSION_MIN_REQUIRED >= GLIB_VERSION_2_56
#define GI_DEPRECATED_IN_2_56 GI_DEPRECATED
#define GI_DEPRECATED_IN_2_56_FOR(f) GI_DEPRECATED_FOR (f)
#define GI_DEPRECATED_MACRO_IN_2_56 GLIB_DEPRECATED_MACRO
#define GI_DEPRECATED_MACRO_IN_2_56_FOR(f) GLIB_DEPRECATED_MACRO_FOR (f)
#define GI_DEPRECATED_ENUMERATOR_IN_2_56 GLIB_DEPRECATED_ENUMERATOR
#define GI_DEPRECATED_ENUMERATOR_IN_2_56_FOR(f) GLIB_DEPRECATED_ENUMERATOR_FOR (f)
#define GI_DEPRECATED_TYPE_IN_2_56 GLIB_DEPRECATED_TYPE
#define GI_DEPRECATED_TYPE_IN_2_56_FOR(f) GLIB_DEPRECATED_TYPE_FOR (f)
#else
#define GI_DEPRECATED_IN_2_56 _GI_EXTERN
#define GI_DEPRECATED_IN_2_56_FOR(f) _GI_EXTERN
#define GI_DEPRECATED_MACRO_IN_2_56
#define GI_DEPRECATED_MACRO_IN_2_56_FOR(f)
#define GI_DEPRECATED_ENUMERATOR_IN_2_56
#define GI_DEPRECATED_ENUMERATOR_IN_2_56_FOR(f)
#define GI_DEPRECATED_TYPE_IN_2_56
#define GI_DEPRECATED_TYPE_IN_2_56_FOR(f)
#endif

#if GLIB_VERSION_MAX_ALLOWED < GLIB_VERSION_2_56
#define GI_AVAILABLE_IN_2_56 GI_UNAVAILABLE (2, 56)
#define GI_AVAILABLE_STATIC_INLINE_IN_2_56 GLIB_UNAVAILABLE_STATIC_INLINE (2, 56)
#define GI_AVAILABLE_MACRO_IN_2_56 GLIB_UNAVAILABLE_MACRO (2, 56)
#define GI_AVAILABLE_ENUMERATOR_IN_2_56 GLIB_UNAVAILABLE_ENUMERATOR (2, 56)
#define GI_AVAILABLE_TYPE_IN_2_56 GLIB_UNAVAILABLE_TYPE (2, 56)
#else
#define GI_AVAILABLE_IN_2_56 _GI_EXTERN
#define GI_AVAILABLE_STATIC_INLINE_IN_2_56
#define GI_AVAILABLE_MACRO_IN_2_56
#define GI_AVAILABLE_ENUMERATOR_IN_2_56
#define GI_AVAILABLE_TYPE_IN_2_56
#endif

#if GLIB_VERSION_MIN_REQUIRED >= GLIB_VERSION_2_58
#define GI_DEPRECATED_IN_2_58 GI_DEPRECATED
#define GI_DEPRECATED_IN_2_58_FOR(f) GI_DEPRECATED_FOR (f)
#define GI_DEPRECATED_MACRO_IN_2_58 GLIB_DEPRECATED_MACRO
#define GI_DEPRECATED_MACRO_IN_2_58_FOR(f) GLIB_DEPRECATED_MACRO_FOR (f)
#define GI_DEPRECATED_ENUMERATOR_IN_2_58 GLIB_DEPRECATED_ENUMERATOR
#define GI_DEPRECATED_ENUMERATOR_IN_2_58_FOR(f) GLIB_DEPRECATED_ENUMERATOR_FOR (f)
#define GI_DEPRECATED_TYPE_IN_2_58 GLIB_DEPRECATED_TYPE
#define GI_DEPRECATED_TYPE_IN_2_58_FOR(f) GLIB_DEPRECATED_TYPE_FOR (f)
#else
#define GI_DEPRECATED_IN_2_58 _GI_EXTERN
#define GI_DEPRECATED_IN_2_58_FOR(f) _GI_EXTERN
#define GI_DEPRECATED_MACRO_IN_2_58
#define GI_DEPRECATED_MACRO_IN_2_58_FOR(f)
#define GI_DEPRECATED_ENUMERATOR_IN_2_58
#define GI_DEPRECATED_ENUMERATOR_IN_2_58_FOR(f)
#define GI_DEPRECATED_TYPE_IN_2_58
#define GI_DEPRECATED_TYPE_IN_2_58_FOR(f)
#endif

#if GLIB_VERSION_MAX_ALLOWED < GLIB_VERSION_2_58
#define GI_AVAILABLE_IN_2_58 GI_UNAVAILABLE (2, 58)
#define GI_AVAILABLE_STATIC_INLINE_IN_2_58 GLIB_UNAVAILABLE_STATIC_INLINE (2, 58)
#define GI_AVAILABLE_MACRO_IN_2_58 GLIB_UNAVAILABLE_MACRO (2, 58)
#define GI_AVAILABLE_ENUMERATOR_IN_2_58 GLIB_UNAVAILABLE_ENUMERATOR (2, 58)
#define GI_AVAILABLE_TYPE_IN_2_58 GLIB_UNAVAILABLE_TYPE (2, 58)
#else
#define GI_AVAILABLE_IN_2_58 _GI_EXTERN
#define GI_AVAILABLE_STATIC_INLINE_IN_2_58
#define GI_AVAILABLE_MACRO_IN_2_58
#define GI_AVAILABLE_ENUMERATOR_IN_2_58
#define GI_AVAILABLE_TYPE_IN_2_58
#endif

#if GLIB_VERSION_MIN_REQUIRED >= GLIB_VERSION_2_60
#define GI_DEPRECATED_IN_2_60 GI_DEPRECATED
#define GI_DEPRECATED_IN_2_60_FOR(f) GI_DEPRECATED_FOR (f)
#define GI_DEPRECATED_MACRO_IN_2_60 GLIB_DEPRECATED_MACRO
#define GI_DEPRECATED_MACRO_IN_2_60_FOR(f) GLIB_DEPRECATED_MACRO_FOR (f)
#define GI_DEPRECATED_ENUMERATOR_IN_2_60 GLIB_DEPRECATED_ENUMERATOR
#define GI_DEPRECATED_ENUMERATOR_IN_2_60_FOR(f) GLIB_DEPRECATED_ENUMERATOR_FOR (f)
#define GI_DEPRECATED_TYPE_IN_2_60 GLIB_DEPRECATED_TYPE
#define GI_DEPRECATED_TYPE_IN_2_60_FOR(f) GLIB_DEPRECATED_TYPE_FOR (f)
#else
#define GI_DEPRECATED_IN_2_60 _GI_EXTERN
#define GI_DEPRECATED_IN_2_60_FOR(f) _GI_EXTERN
#define GI_DEPRECATED_MACRO_IN_2_60
#define GI_DEPRECATED_MACRO_IN_2_60_FOR(f)
#define GI_DEPRECATED_ENUMERATOR_IN_2_60
#define GI_DEPRECATED_ENUMERATOR_IN_2_60_FOR(f)
#define GI_DEPRECATED_TYPE_IN_2_60
#define GI_DEPRECATED_TYPE_IN_2_60_FOR(f)
#endif

#if GLIB_VERSION_MAX_ALLOWED < GLIB_VERSION_2_60
#define GI_AVAILABLE_IN_2_60 GI_UNAVAILABLE (2, 60)
#define GI_AVAILABLE_STATIC_INLINE_IN_2_60 GLIB_UNAVAILABLE_STATIC_INLINE (2, 60)
#define GI_AVAILABLE_MACRO_IN_2_60 GLIB_UNAVAILABLE_MACRO (2, 60)
#define GI_AVAILABLE_ENUMERATOR_IN_2_60 GLIB_UNAVAILABLE_ENUMERATOR (2, 60)
#define GI_AVAILABLE_TYPE_IN_2_60 GLIB_UNAVAILABLE_TYPE (2, 60)
#else
#define GI_AVAILABLE_IN_2_60 _GI_EXTERN
#define GI_AVAILABLE_STATIC_INLINE_IN_2_60
#define GI_AVAILABLE_MACRO_IN_2_60
#define GI_AVAILABLE_ENUMERATOR_IN_2_60
#define GI_AVAILABLE_TYPE_IN_2_60
#endif

#if GLIB_VERSION_MIN_REQUIRED >= GLIB_VERSION_2_62
#define GI_DEPRECATED_IN_2_62 GI_DEPRECATED
#define GI_DEPRECATED_IN_2_62_FOR(f) GI_DEPRECATED_FOR (f)
#define GI_DEPRECATED_MACRO_IN_2_62 GLIB_DEPRECATED_MACRO
#define GI_DEPRECATED_MACRO_IN_2_62_FOR(f) GLIB_DEPRECATED_MACRO_FOR (f)
#define GI_DEPRECATED_ENUMERATOR_IN_2_62 GLIB_DEPRECATED_ENUMERATOR
#define GI_DEPRECATED_ENUMERATOR_IN_2_62_FOR(f) GLIB_DEPRECATED_ENUMERATOR_FOR (f)
#define GI_DEPRECATED_TYPE_IN_2_62 GLIB_DEPRECATED_TYPE
#define GI_DEPRECATED_TYPE_IN_2_62_FOR(f) GLIB_DEPRECATED_TYPE_FOR (f)
#else
#define GI_DEPRECATED_IN_2_62 _GI_EXTERN
#define GI_DEPRECATED_IN_2_62_FOR(f) _GI_EXTERN
#define GI_DEPRECATED_MACRO_IN_2_62
#define GI_DEPRECATED_MACRO_IN_2_62_FOR(f)
#define GI_DEPRECATED_ENUMERATOR_IN_2_62
#define GI_DEPRECATED_ENUMERATOR_IN_2_62_FOR(f)
#define GI_DEPRECATED_TYPE_IN_2_62
#define GI_DEPRECATED_TYPE_IN_2_62_FOR(f)
#endif

#if GLIB_VERSION_MAX_ALLOWED < GLIB_VERSION_2_62
#define GI_AVAILABLE_IN_2_62 GI_UNAVAILABLE (2, 62)
#define GI_AVAILABLE_STATIC_INLINE_IN_2_62 GLIB_UNAVAILABLE_STATIC_INLINE (2, 62)
#define GI_AVAILABLE_MACRO_IN_2_62 GLIB_UNAVAILABLE_MACRO (2, 62)
#define GI_AVAILABLE_ENUMERATOR_IN_2_62 GLIB_UNAVAILABLE_ENUMERATOR (2, 62)
#define GI_AVAILABLE_TYPE_IN_2_62 GLIB_UNAVAILABLE_TYPE (2, 62)
#else
#define GI_AVAILABLE_IN_2_62 _GI_EXTERN
#define GI_AVAILABLE_STATIC_INLINE_IN_2_62
#define GI_AVAILABLE_MACRO_IN_2_62
#define GI_AVAILABLE_ENUMERATOR_IN_2_62
#define GI_AVAILABLE_TYPE_IN_2_62
#endif

#if GLIB_VERSION_MIN_REQUIRED >= GLIB_VERSION_2_64
#define GI_DEPRECATED_IN_2_64 GI_DEPRECATED
#define GI_DEPRECATED_IN_2_64_FOR(f) GI_DEPRECATED_FOR (f)
#define GI_DEPRECATED_MACRO_IN_2_64 GLIB_DEPRECATED_MACRO
#define GI_DEPRECATED_MACRO_IN_2_64_FOR(f) GLIB_DEPRECATED_MACRO_FOR (f)
#define GI_DEPRECATED_ENUMERATOR_IN_2_64 GLIB_DEPRECATED_ENUMERATOR
#define GI_DEPRECATED_ENUMERATOR_IN_2_64_FOR(f) GLIB_DEPRECATED_ENUMERATOR_FOR (f)
#define GI_DEPRECATED_TYPE_IN_2_64 GLIB_DEPRECATED_TYPE
#define GI_DEPRECATED_TYPE_IN_2_64_FOR(f) GLIB_DEPRECATED_TYPE_FOR (f)
#else
#define GI_DEPRECATED_IN_2_64 _GI_EXTERN
#define GI_DEPRECATED_IN_2_64_FOR(f) _GI_EXTERN
#define GI_DEPRECATED_MACRO_IN_2_64
#define GI_DEPRECATED_MACRO_IN_2_64_FOR(f)
#define GI_DEPRECATED_ENUMERATOR_IN_2_64
#define GI_DEPRECATED_ENUMERATOR_IN_2_64_FOR(f)
#define GI_DEPRECATED_TYPE_IN_2_64
#define GI_DEPRECATED_TYPE_IN_2_64_FOR(f)
#endif

#if GLIB_VERSION_MAX_ALLOWED < GLIB_VERSION_2_64
#define GI_AVAILABLE_IN_2_64 GI_UNAVAILABLE (2, 64)
#define GI_AVAILABLE_STATIC_INLINE_IN_2_64 GLIB_UNAVAILABLE_STATIC_INLINE (2, 64)
#define GI_AVAILABLE_MACRO_IN_2_64 GLIB_UNAVAILABLE_MACRO (2, 64)
#define GI_AVAILABLE_ENUMERATOR_IN_2_64 GLIB_UNAVAILABLE_ENUMERATOR (2, 64)
#define GI_AVAILABLE_TYPE_IN_2_64 GLIB_UNAVAILABLE_TYPE (2, 64)
#else
#define GI_AVAILABLE_IN_2_64 _GI_EXTERN
#define GI_AVAILABLE_STATIC_INLINE_IN_2_64
#define GI_AVAILABLE_MACRO_IN_2_64
#define GI_AVAILABLE_ENUMERATOR_IN_2_64
#define GI_AVAILABLE_TYPE_IN_2_64
#endif

#if GLIB_VERSION_MIN_REQUIRED >= GLIB_VERSION_2_66
#define GI_DEPRECATED_IN_2_66 GI_DEPRECATED
#define GI_DEPRECATED_IN_2_66_FOR(f) GI_DEPRECATED_FOR (f)
#define GI_DEPRECATED_MACRO_IN_2_66 GLIB_DEPRECATED_MACRO
#define GI_DEPRECATED_MACRO_IN_2_66_FOR(f) GLIB_DEPRECATED_MACRO_FOR (f)
#define GI_DEPRECATED_ENUMERATOR_IN_2_66 GLIB_DEPRECATED_ENUMERATOR
#define GI_DEPRECATED_ENUMERATOR_IN_2_66_FOR(f) GLIB_DEPRECATED_ENUMERATOR_FOR (f)
#define GI_DEPRECATED_TYPE_IN_2_66 GLIB_DEPRECATED_TYPE
#define GI_DEPRECATED_TYPE_IN_2_66_FOR(f) GLIB_DEPRECATED_TYPE_FOR (f)
#else
#define GI_DEPRECATED_IN_2_66 _GI_EXTERN
#define GI_DEPRECATED_IN_2_66_FOR(f) _GI_EXTERN
#define GI_DEPRECATED_MACRO_IN_2_66
#define GI_DEPRECATED_MACRO_IN_2_66_FOR(f)
#define GI_DEPRECATED_ENUMERATOR_IN_2_66
#define GI_DEPRECATED_ENUMERATOR_IN_2_66_FOR(f)
#define GI_DEPRECATED_TYPE_IN_2_66
#define GI_DEPRECATED_TYPE_IN_2_66_FOR(f)
#endif

#if GLIB_VERSION_MAX_ALLOWED < GLIB_VERSION_2_66
#define GI_AVAILABLE_IN_2_66 GI_UNAVAILABLE (2, 66)
#define GI_AVAILABLE_STATIC_INLINE_IN_2_66 GLIB_UNAVAILABLE_STATIC_INLINE (2, 66)
#define GI_AVAILABLE_MACRO_IN_2_66 GLIB_UNAVAILABLE_MACRO (2, 66)
#define GI_AVAILABLE_ENUMERATOR_IN_2_66 GLIB_UNAVAILABLE_ENUMERATOR (2, 66)
#define GI_AVAILABLE_TYPE_IN_2_66 GLIB_UNAVAILABLE_TYPE (2, 66)
#else
#define GI_AVAILABLE_IN_2_66 _GI_EXTERN
#define GI_AVAILABLE_STATIC_INLINE_IN_2_66
#define GI_AVAILABLE_MACRO_IN_2_66
#define GI_AVAILABLE_ENUMERATOR_IN_2_66
#define GI_AVAILABLE_TYPE_IN_2_66
#endif

#if GLIB_VERSION_MIN_REQUIRED >= GLIB_VERSION_2_68
#define GI_DEPRECATED_IN_2_68 GI_DEPRECATED
#define GI_DEPRECATED_IN_2_68_FOR(f) GI_DEPRECATED_FOR (f)
#define GI_DEPRECATED_MACRO_IN_2_68 GLIB_DEPRECATED_MACRO
#define GI_DEPRECATED_MACRO_IN_2_68_FOR(f) GLIB_DEPRECATED_MACRO_FOR (f)
#define GI_DEPRECATED_ENUMERATOR_IN_2_68 GLIB_DEPRECATED_ENUMERATOR
#define GI_DEPRECATED_ENUMERATOR_IN_2_68_FOR(f) GLIB_DEPRECATED_ENUMERATOR_FOR (f)
#define GI_DEPRECATED_TYPE_IN_2_68 GLIB_DEPRECATED_TYPE
#define GI_DEPRECATED_TYPE_IN_2_68_FOR(f) GLIB_DEPRECATED_TYPE_FOR (f)
#else
#define GI_DEPRECATED_IN_2_68 _GI_EXTERN
#define GI_DEPRECATED_IN_2_68_FOR(f) _GI_EXTERN
#define GI_DEPRECATED_MACRO_IN_2_68
#define GI_DEPRECATED_MACRO_IN_2_68_FOR(f)
#define GI_DEPRECATED_ENUMERATOR_IN_2_68
#define GI_DEPRECATED_ENUMERATOR_IN_2_68_FOR(f)
#define GI_DEPRECATED_TYPE_IN_2_68
#define GI_DEPRECATED_TYPE_IN_2_68_FOR(f)
#endif

#if GLIB_VERSION_MAX_ALLOWED < GLIB_VERSION_2_68
#define GI_AVAILABLE_IN_2_68 GI_UNAVAILABLE (2, 68)
#define GI_AVAILABLE_STATIC_INLINE_IN_2_68 GLIB_UNAVAILABLE_STATIC_INLINE (2, 68)
#define GI_AVAILABLE_MACRO_IN_2_68 GLIB_UNAVAILABLE_MACRO (2, 68)
#define GI_AVAILABLE_ENUMERATOR_IN_2_68 GLIB_UNAVAILABLE_ENUMERATOR (2, 68)
#define GI_AVAILABLE_TYPE_IN_2_68 GLIB_UNAVAILABLE_TYPE (2, 68)
#else
#define GI_AVAILABLE_IN_2_68 _GI_EXTERN
#define GI_AVAILABLE_STATIC_INLINE_IN_2_68
#define GI_AVAILABLE_MACRO_IN_2_68
#define GI_AVAILABLE_ENUMERATOR_IN_2_68
#define GI_AVAILABLE_TYPE_IN_2_68
#endif

#if GLIB_VERSION_MIN_REQUIRED >= GLIB_VERSION_2_70
#define GI_DEPRECATED_IN_2_70 GI_DEPRECATED
#define GI_DEPRECATED_IN_2_70_FOR(f) GI_DEPRECATED_FOR (f)
#define GI_DEPRECATED_MACRO_IN_2_70 GLIB_DEPRECATED_MACRO
#define GI_DEPRECATED_MACRO_IN_2_70_FOR(f) GLIB_DEPRECATED_MACRO_FOR (f)
#define GI_DEPRECATED_ENUMERATOR_IN_2_70 GLIB_DEPRECATED_ENUMERATOR
#define GI_DEPRECATED_ENUMERATOR_IN_2_70_FOR(f) GLIB_DEPRECATED_ENUMERATOR_FOR (f)
#define GI_DEPRECATED_TYPE_IN_2_70 GLIB_DEPRECATED_TYPE
#define GI_DEPRECATED_TYPE_IN_2_70_FOR(f) GLIB_DEPRECATED_TYPE_FOR (f)
#else
#define GI_DEPRECATED_IN_2_70 _GI_EXTERN
#define GI_DEPRECATED_IN_2_70_FOR(f) _GI_EXTERN
#define GI_DEPRECATED_MACRO_IN_2_70
#define GI_DEPRECATED_MACRO_IN_2_70_FOR(f)
#define GI_DEPRECATED_ENUMERATOR_IN_2_70
#define GI_DEPRECATED_ENUMERATOR_IN_2_70_FOR(f)
#define GI_DEPRECATED_TYPE_IN_2_70
#define GI_DEPRECATED_TYPE_IN_2_70_FOR(f)
#endif

#if GLIB_VERSION_MAX_ALLOWED < GLIB_VERSION_2_70
#define GI_AVAILABLE_IN_2_70 GI_UNAVAILABLE (2, 70)
#define GI_AVAILABLE_STATIC_INLINE_IN_2_70 GLIB_UNAVAILABLE_STATIC_INLINE (2, 70)
#define GI_AVAILABLE_MACRO_IN_2_70 GLIB_UNAVAILABLE_MACRO (2, 70)
#define GI_AVAILABLE_ENUMERATOR_IN_2_70 GLIB_UNAVAILABLE_ENUMERATOR (2, 70)
#define GI_AVAILABLE_TYPE_IN_2_70 GLIB_UNAVAILABLE_TYPE (2, 70)
#else
#define GI_AVAILABLE_IN_2_70 _GI_EXTERN
#define GI_AVAILABLE_STATIC_INLINE_IN_2_70
#define GI_AVAILABLE_MACRO_IN_2_70
#define GI_AVAILABLE_ENUMERATOR_IN_2_70
#define GI_AVAILABLE_TYPE_IN_2_70
#endif

#if GLIB_VERSION_MIN_REQUIRED >= GLIB_VERSION_2_72
#define GI_DEPRECATED_IN_2_72 GI_DEPRECATED
#define GI_DEPRECATED_IN_2_72_FOR(f) GI_DEPRECATED_FOR (f)
#define GI_DEPRECATED_MACRO_IN_2_72 GLIB_DEPRECATED_MACRO
#define GI_DEPRECATED_MACRO_IN_2_72_FOR(f) GLIB_DEPRECATED_MACRO_FOR (f)
#define GI_DEPRECATED_ENUMERATOR_IN_2_72 GLIB_DEPRECATED_ENUMERATOR
#define GI_DEPRECATED_ENUMERATOR_IN_2_72_FOR(f) GLIB_DEPRECATED_ENUMERATOR_FOR (f)
#define GI_DEPRECATED_TYPE_IN_2_72 GLIB_DEPRECATED_TYPE
#define GI_DEPRECATED_TYPE_IN_2_72_FOR(f) GLIB_DEPRECATED_TYPE_FOR (f)
#else
#define GI_DEPRECATED_IN_2_72 _GI_EXTERN
#define GI_DEPRECATED_IN_2_72_FOR(f) _GI_EXTERN
#define GI_DEPRECATED_MACRO_IN_2_72
#define GI_DEPRECATED_MACRO_IN_2_72_FOR(f)
#define GI_DEPRECATED_ENUMERATOR_IN_2_72
#define GI_DEPRECATED_ENUMERATOR_IN_2_72_FOR(f)
#define GI_DEPRECATED_TYPE_IN_2_72
#define GI_DEPRECATED_TYPE_IN_2_72_FOR(f)
#endif

#if GLIB_VERSION_MAX_ALLOWED < GLIB_VERSION_2_72
#define GI_AVAILABLE_IN_2_72 GI_UNAVAILABLE (2, 72)
#define GI_AVAILABLE_STATIC_INLINE_IN_2_72 GLIB_UNAVAILABLE_STATIC_INLINE (2, 72)
#define GI_AVAILABLE_MACRO_IN_2_72 GLIB_UNAVAILABLE_MACRO (2, 72)
#define GI_AVAILABLE_ENUMERATOR_IN_2_72 GLIB_UNAVAILABLE_ENUMERATOR (2, 72)
#define GI_AVAILABLE_TYPE_IN_2_72 GLIB_UNAVAILABLE_TYPE (2, 72)
#else
#define GI_AVAILABLE_IN_2_72 _GI_EXTERN
#define GI_AVAILABLE_STATIC_INLINE_IN_2_72
#define GI_AVAILABLE_MACRO_IN_2_72
#define GI_AVAILABLE_ENUMERATOR_IN_2_72
#define GI_AVAILABLE_TYPE_IN_2_72
#endif

#if GLIB_VERSION_MIN_REQUIRED >= GLIB_VERSION_2_74
#define GI_DEPRECATED_IN_2_74 GI_DEPRECATED
#define GI_DEPRECATED_IN_2_74_FOR(f) GI_DEPRECATED_FOR (f)
#define GI_DEPRECATED_MACRO_IN_2_74 GLIB_DEPRECATED_MACRO
#define GI_DEPRECATED_MACRO_IN_2_74_FOR(f) GLIB_DEPRECATED_MACRO_FOR (f)
#define GI_DEPRECATED_ENUMERATOR_IN_2_74 GLIB_DEPRECATED_ENUMERATOR
#define GI_DEPRECATED_ENUMERATOR_IN_2_74_FOR(f) GLIB_DEPRECATED_ENUMERATOR_FOR (f)
#define GI_DEPRECATED_TYPE_IN_2_74 GLIB_DEPRECATED_TYPE
#define GI_DEPRECATED_TYPE_IN_2_74_FOR(f) GLIB_DEPRECATED_TYPE_FOR (f)
#else
#define GI_DEPRECATED_IN_2_74 _GI_EXTERN
#define GI_DEPRECATED_IN_2_74_FOR(f) _GI_EXTERN
#define GI_DEPRECATED_MACRO_IN_2_74
#define GI_DEPRECATED_MACRO_IN_2_74_FOR(f)
#define GI_DEPRECATED_ENUMERATOR_IN_2_74
#define GI_DEPRECATED_ENUMERATOR_IN_2_74_FOR(f)
#define GI_DEPRECATED_TYPE_IN_2_74
#define GI_DEPRECATED_TYPE_IN_2_74_FOR(f)
#endif

#if GLIB_VERSION_MAX_ALLOWED < GLIB_VERSION_2_74
#define GI_AVAILABLE_IN_2_74 GI_UNAVAILABLE (2, 74)
#define GI_AVAILABLE_STATIC_INLINE_IN_2_74 GLIB_UNAVAILABLE_STATIC_INLINE (2, 74)
#define GI_AVAILABLE_MACRO_IN_2_74 GLIB_UNAVAILABLE_MACRO (2, 74)
#define GI_AVAILABLE_ENUMERATOR_IN_2_74 GLIB_UNAVAILABLE_ENUMERATOR (2, 74)
#define GI_AVAILABLE_TYPE_IN_2_74 GLIB_UNAVAILABLE_TYPE (2, 74)
#else
#define GI_AVAILABLE_IN_2_74 _GI_EXTERN
#define GI_AVAILABLE_STATIC_INLINE_IN_2_74
#define GI_AVAILABLE_MACRO_IN_2_74
#define GI_AVAILABLE_ENUMERATOR_IN_2_74
#define GI_AVAILABLE_TYPE_IN_2_74
#endif

#if GLIB_VERSION_MIN_REQUIRED >= GLIB_VERSION_2_76
#define GI_DEPRECATED_IN_2_76 GI_DEPRECATED
#define GI_DEPRECATED_IN_2_76_FOR(f) GI_DEPRECATED_FOR (f)
#define GI_DEPRECATED_MACRO_IN_2_76 GLIB_DEPRECATED_MACRO
#define GI_DEPRECATED_MACRO_IN_2_76_FOR(f) GLIB_DEPRECATED_MACRO_FOR (f)
#define GI_DEPRECATED_ENUMERATOR_IN_2_76 GLIB_DEPRECATED_ENUMERATOR
#define GI_DEPRECATED_ENUMERATOR_IN_2_76_FOR(f) GLIB_DEPRECATED_ENUMERATOR_FOR (f)
#define GI_DEPRECATED_TYPE_IN_2_76 GLIB_DEPRECATED_TYPE
#define GI_DEPRECATED_TYPE_IN_2_76_FOR(f) GLIB_DEPRECATED_TYPE_FOR (f)
#else
#define GI_DEPRECATED_IN_2_76 _GI_EXTERN
#define GI_DEPRECATED_IN_2_76_FOR(f) _GI_EXTERN
#define GI_DEPRECATED_MACRO_IN_2_76
#define GI_DEPRECATED_MACRO_IN_2_76_FOR(f)
#define GI_DEPRECATED_ENUMERATOR_IN_2_76
#define GI_DEPRECATED_ENUMERATOR_IN_2_76_FOR(f)
#define GI_DEPRECATED_TYPE_IN_2_76
#define GI_DEPRECATED_TYPE_IN_2_76_FOR(f)
#endif

#if GLIB_VERSION_MAX_ALLOWED < GLIB_VERSION_2_76
#define GI_AVAILABLE_IN_2_76 GI_UNAVAILABLE (2, 76)
#define GI_AVAILABLE_STATIC_INLINE_IN_2_76 GLIB_UNAVAILABLE_STATIC_INLINE (2, 76)
#define GI_AVAILABLE_MACRO_IN_2_76 GLIB_UNAVAILABLE_MACRO (2, 76)
#define GI_AVAILABLE_ENUMERATOR_IN_2_76 GLIB_UNAVAILABLE_ENUMERATOR (2, 76)
#define GI_AVAILABLE_TYPE_IN_2_76 GLIB_UNAVAILABLE_TYPE (2, 76)
#else
#define GI_AVAILABLE_IN_2_76 _GI_EXTERN
#define GI_AVAILABLE_STATIC_INLINE_IN_2_76
#define GI_AVAILABLE_MACRO_IN_2_76
#define GI_AVAILABLE_ENUMERATOR_IN_2_76
#define GI_AVAILABLE_TYPE_IN_2_76
#endif

#if GLIB_VERSION_MIN_REQUIRED >= GLIB_VERSION_2_78
#define GI_DEPRECATED_IN_2_78 GI_DEPRECATED
#define GI_DEPRECATED_IN_2_78_FOR(f) GI_DEPRECATED_FOR (f)
#define GI_DEPRECATED_MACRO_IN_2_78 GLIB_DEPRECATED_MACRO
#define GI_DEPRECATED_MACRO_IN_2_78_FOR(f) GLIB_DEPRECATED_MACRO_FOR (f)
#define GI_DEPRECATED_ENUMERATOR_IN_2_78 GLIB_DEPRECATED_ENUMERATOR
#define GI_DEPRECATED_ENUMERATOR_IN_2_78_FOR(f) GLIB_DEPRECATED_ENUMERATOR_FOR (f)
#define GI_DEPRECATED_TYPE_IN_2_78 GLIB_DEPRECATED_TYPE
#define GI_DEPRECATED_TYPE_IN_2_78_FOR(f) GLIB_DEPRECATED_TYPE_FOR (f)
#else
#define GI_DEPRECATED_IN_2_78 _GI_EXTERN
#define GI_DEPRECATED_IN_2_78_FOR(f) _GI_EXTERN
#define GI_DEPRECATED_MACRO_IN_2_78
#define GI_DEPRECATED_MACRO_IN_2_78_FOR(f)
#define GI_DEPRECATED_ENUMERATOR_IN_2_78
#define GI_DEPRECATED_ENUMERATOR_IN_2_78_FOR(f)
#define GI_DEPRECATED_TYPE_IN_2_78
#define GI_DEPRECATED_TYPE_IN_2_78_FOR(f)
#endif

#if GLIB_VERSION_MAX_ALLOWED < GLIB_VERSION_2_78
#define GI_AVAILABLE_IN_2_78 GI_UNAVAILABLE (2, 78)
#define GI_AVAILABLE_STATIC_INLINE_IN_2_78 GLIB_UNAVAILABLE_STATIC_INLINE (2, 78)
#define GI_AVAILABLE_MACRO_IN_2_78 GLIB_UNAVAILABLE_MACRO (2, 78)
#define GI_AVAILABLE_ENUMERATOR_IN_2_78 GLIB_UNAVAILABLE_ENUMERATOR (2, 78)
#define GI_AVAILABLE_TYPE_IN_2_78 GLIB_UNAVAILABLE_TYPE (2, 78)
#else
#define GI_AVAILABLE_IN_2_78 _GI_EXTERN
#define GI_AVAILABLE_STATIC_INLINE_IN_2_78
#define GI_AVAILABLE_MACRO_IN_2_78
#define GI_AVAILABLE_ENUMERATOR_IN_2_78
#define GI_AVAILABLE_TYPE_IN_2_78
#endif

#if GLIB_VERSION_MIN_REQUIRED >= GLIB_VERSION_2_80
#define GI_DEPRECATED_IN_2_80 GI_DEPRECATED
#define GI_DEPRECATED_IN_2_80_FOR(f) GI_DEPRECATED_FOR (f)
#define GI_DEPRECATED_MACRO_IN_2_80 GLIB_DEPRECATED_MACRO
#define GI_DEPRECATED_MACRO_IN_2_80_FOR(f) GLIB_DEPRECATED_MACRO_FOR (f)
#define GI_DEPRECATED_ENUMERATOR_IN_2_80 GLIB_DEPRECATED_ENUMERATOR
#define GI_DEPRECATED_ENUMERATOR_IN_2_80_FOR(f) GLIB_DEPRECATED_ENUMERATOR_FOR (f)
#define GI_DEPRECATED_TYPE_IN_2_80 GLIB_DEPRECATED_TYPE
#define GI_DEPRECATED_TYPE_IN_2_80_FOR(f) GLIB_DEPRECATED_TYPE_FOR (f)
#else
#define GI_DEPRECATED_IN_2_80 _GI_EXTERN
#define GI_DEPRECATED_IN_2_80_FOR(f) _GI_EXTERN
#define GI_DEPRECATED_MACRO_IN_2_80
#define GI_DEPRECATED_MACRO_IN_2_80_FOR(f)
#define GI_DEPRECATED_ENUMERATOR_IN_2_80
#define GI_DEPRECATED_ENUMERATOR_IN_2_80_FOR(f)
#define GI_DEPRECATED_TYPE_IN_2_80
#define GI_DEPRECATED_TYPE_IN_2_80_FOR(f)
#endif

#if GLIB_VERSION_MAX_ALLOWED < GLIB_VERSION_2_80
#define GI_AVAILABLE_IN_2_80 GI_UNAVAILABLE (2, 80)
#define GI_AVAILABLE_STATIC_INLINE_IN_2_80 GLIB_UNAVAILABLE_STATIC_INLINE (2, 80)
#define GI_AVAILABLE_MACRO_IN_2_80 GLIB_UNAVAILABLE_MACRO (2, 80)
#define GI_AVAILABLE_ENUMERATOR_IN_2_80 GLIB_UNAVAILABLE_ENUMERATOR (2, 80)
#define GI_AVAILABLE_TYPE_IN_2_80 GLIB_UNAVAILABLE_TYPE (2, 80)
#else
#define GI_AVAILABLE_IN_2_80 _GI_EXTERN
#define GI_AVAILABLE_STATIC_INLINE_IN_2_80
#define GI_AVAILABLE_MACRO_IN_2_80
#define GI_AVAILABLE_ENUMERATOR_IN_2_80
#define GI_AVAILABLE_TYPE_IN_2_80
#endif
